# aiwolf-cndl@cedec2017

第3回人狼知能大会に提出したプログラムのソースコードです。


## ビルド

依存ライブラリはaiwolfライブラリのver0.4.9のみです。
ビルドファイルはありませんが、一応eclipseのプロジェクトになっているので読み込めばeclipseからビルド可能です。
libフォルダ下にaiwolfライブラリのjarが入っていることが想定されています。


## 実行

toolsのRunner.javaからテスト実行することが可能です。
config下の設定ファイルを使って起動します。
詳細ログを出力する場合、Utils.javaのIS_Productionフラグをfalseにします。

## カスタマイズする場合

### Tacticの変更

TalkTacticかTargetTacticを継承したクラスを作成し、各Roleの適切なtacticsにaddして下さい。
なお、今回の実装では各Tacticはアダプタークラスを拡張し、キャスとされたモデルを使えるようにしています。


### MetagameModelの変更

MetagameModelを継承したクラスを作成し、AbstractPlayerを実装したクラスでインスタンスを返すようにして下さい。

### GameModelの変更

GameModelを継承したクラスを作成し、AbstractRoleを実装したクラスでインスタンスを返すようにして下さい。
今回の実装では、Role毎に使うモデルは変わらないため、各Roleの継承元のTFAFBaseRoleでモデルを作成しています。

### イベントの発生順について


| 日                        | 人狼サーバの処理           | Game                                                          | 発生するGameEvent                                        | 各Role               |
|---------------------------|----------------------------|---------------------------------------------------------------|----------------------------------------------------------|----------------------|
|                           | （ゲーム開始）             |                                                               |                                                          |                      |
|                           | initialize                 | ・初期状態の作成・エージェントの作成・Metagameのstartメソッド |                                                          |                      |
|                           |                            |                                                               |                                                          | Roleのコンストラクタ |
|                           | update                     |                                                               |                                                          |                      |
| 0日目スタート             | dayStart                   |                                                               |                                                          |                      |
|                           |                            |                                                               |                                                          |                      |
| 初夜                      | <人狼のみ>                 |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
| ※人狼が一人だと呼ばれない | whisper                    |                                                               |                                                          |                      |
|                           | update                     |                                                               | ささやきの結果（Whisper）                                |                      |
|                           | whisper                    |                                                               |                                                          |                      |
|                           | ...                        |                                                               | ※バグなのか、一番最後のWhisperはその後のupdateで取得不可 |                      |
|                           | <占い師のみ>               |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
|                           | divine                     |                                                               |                                                          | divine               |
|                           |                            |                                                               |                                                          |                      |
| 1日目スタート             | update                     |                                                               | 一日目開始（DAYSTART）                                   |                      |
|                           |                            |                                                               | 占い師なら0日目の結果（DIVINE）                          |                      |
|                           | dayStart                   |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
|                           | talk                       |                                                               |                                                          | talk                 |
|                           | update                     |                                                               | 先ほどの会話結果（TALK）                                 |                      |
| 繰り返し                  | …                          |                                                               |                                                          |                      |
|                           | update                     |                                                               | 最後の会話結果                                           |                      |
|                           | vote                       |                                                               |                                                          | vote                 |
|                           | <決選投票の時のみ>         |                                                               |                                                          |                      |
|                           | update                     |                                                               | 先ほどの投票結果（VOTE）                                 |                      |
|                           | vote                       |                                                               |                                                          | revote               |
|                           | <占い師のみ>               |                                                               |                                                          |                      |
|                           | update                     |                                                               | 投票結果                                                 |                      |
|                           |                            |                                                               | 吊された人（EXECUTE）                                    |                      |
|                           | divine                     |                                                               |                                                          | divine               |
|                           | <狩人のみ>                 |                                                               |                                                          |                      |
|                           | update                     |                                                               | 投票結果                                                 |                      |
|                           |                            |                                                               | 吊された人                                               |                      |
|                           | guard                      |                                                               |                                                          | guard                |
|                           | <人狼のみ>                 |                                                               |                                                          |                      |
|                           | update                     |                                                               | 投票結果                                                 |                      |
|                           |                            |                                                               | 吊された人                                               |                      |
| ※人狼が一人だと呼ばれない | whisper                    |                                                               |                                                          |                      |
|                           | update                     |                                                               | ささやきの結果                                           |                      |
|                           | whisper                    |                                                               |                                                          |                      |
| 繰り返し                  | …                          |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
|                           | attack                     |                                                               |                                                          | attack               |
|                           | <決選投票の時のみ>         |                                                               |                                                          |                      |
|                           | update                     |                                                               | 先ほどの投票結果                                         |                      |
|                           | attack                     |                                                               |                                                          | reattack             |
| 1日目スタート             | update                     |                                                               | 一日目開始のDAYSTARTイベント                             |                      |
|                           |                            |                                                               | 占い師なら1日目の結果                                    |                      |
|                           |                            |                                                               | 狼の攻撃が成功していればATTACKイベントで襲撃対象が判る   |                      |
|                           |                            |                                                               | 狼の攻撃が失敗した場合、GAURDイベントを出す              |                      |
|                           |                            |                                                               | 霊能者なら昨日死んだ人の判定のMEDIUMイベント             |                      |
|                           |                            |                                                               | 霊能・村人の場合、昨日の投票で死んだ人が判る（EXECUTE）  |                      |
|                           |                            |                                                               | 霊能・村人の場合、昨日の皆さんの投票結果が判る           |                      |
|                           |                            |                                                               | 狼の場合、昨日の襲撃投票結果が判る。（VICTIM_DECIDED）   |                      |
|                           | dayStart                   |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
|                           | talk                       |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
|                           | …                          |                                                               |                                                          |                      |
|                           | 以下ゲーム終了まで繰り返し |                                                               |                                                          |                      |
|                           |                            |                                                               |                                                          |                      |
|                           |                            |                                                               |                                                          |                      |
|                           | <ゲームが終了すると>       |                                                               |                                                          |                      |
|                           | update                     |                                                               |                                                          |                      |
|                           | finish                     | Metagameのfinish                                              |                                                          |                      |
|                           | update                     | →2回目以降は処理しないようにしている                          |                                                          |                      |
|                           | finish                     |                                                               |                                                          |                      |


## ライセンス

The MIT License

Copyright (c) 2017 AKIMASA Kitajima

以下に定める条件に従い、本ソフトウェアおよび関連文書のファイル（以下「ソフトウェア」）の複製を取得するすべての人に対し、ソフトウェアを無制限に扱うことを無償で許可します。これには、ソフトウェアの複製を使用、複写、変更、結合、掲載、頒布、サブライセンス、および/または販売する権利、およびソフトウェアを提供する相手に同じことを許可する権利も無制限に含まれます。

上記の著作権表示および本許諾表示を、ソフトウェアのすべての複製または重要な部分に記載するものとします。

ソフトウェアは「現状のまま」で、明示であるか暗黙であるかを問わず、何らの保証もなく提供されます。ここでいう保証とは、商品性、特定の目的への適合性、および権利非侵害についての保証も含みますが、それに限定されるものではありません。 作者または著作権者は、契約行為、不法行為、またはそれ以外であろうと、ソフトウェアに起因または関連し、あるいはソフトウェアの使用またはその他の扱いによって生じる一切の請求、損害、その他の義務について何らの責任も負わないものとします。